CompositeKey
Keywords: net.corda.core.crypto.CompositeKey class
Date: 2023-09-18

net.corda.core.crypto

## Class CompositeKey

- net.corda.core.crypto.CompositeKey

-     public class CompositeKey

  A tree data structure that enables the representation of composite public keys, which are used to represent the signing requirements for multi-signature scenarios such as RAFT notary services. A composite key is a list of leaf keys and their contributing weight, and each leaf can be a conventional single key or a composite key. Keys contribute their weight to the total if they are matched by the signature.

  For complex scenarios, such as "Both Alice and Bob need to sign to consume a state S", we can represent the requirement by creating a tree with a root `class CompositeKey`, and Alice and Bob as children. The root node would specify weights for each of its children and a threshold – the minimum total weight required (e.g. the minimum number of child signatures required) to satisfy the tree signature requirement.

  Using these constructs we can express e.g. 1 of N (OR) or N of N (AND) signature requirements. By nesting we can create multi-level requirements such as "either the CEO or 3 of 5 of his assistants need to sign".

  See Also:
    `class CompositeKey`

- - ### Field Detail

    - #### KEY_ALGORITHM

          @NotNull
          public static java.lang.String KEY_ALGORITHM

      See Also:
        Constant Field Values

    - #### Companion

          public static net.corda.core.crypto.CompositeKey.Companion Companion

  - ### Method Detail

    - #### getChildren

          @NotNull
          public java.util.List<net.corda.core.crypto.CompositeKey.NodeAndWeight> getChildren()

      Τhe order of the children may not be the same to what was provided in the builder.

    - #### checkValidity

          public void checkValidity()

      This method will detect graph cycles in the full composite key structure to protect against infinite loops when traversing the graph and key duplicates in the each layer. It also checks if the threshold and weight constraint requirements are met, while it tests for aggregated-weight integer overflow. In practice, this method should be always invoked on the root `class CompositeKey`, as it inherently validates the child nodes (all the way till the leaves).

      See Also:
        `class CompositeKey`

    - #### isFulfilledBy

          public boolean isFulfilledBy(@NotNull
                                       java.security.PublicKey key)

      Takes single PublicKey and checks if `class CompositeKey` requirements hold for that key.

      See Also:
        PublicKey, `class CompositeKey`

    - #### getAlgorithm

          @NotNull
          public java.lang.String getAlgorithm()

    - #### getEncoded

          @NotNull
          public kotlin.Array[] getEncoded()

    - #### getFormat

          @NotNull
          public java.lang.String getFormat()

    - #### isFulfilledBy

          public boolean isFulfilledBy(@NotNull
                                       java.lang.Iterable<? extends java.security.PublicKey> keysToCheck)

      Function checks if the public keys corresponding to the signatures are matched against the leaves of the composite key tree in question, and the total combined weight of all children is calculated for every intermediary node. If all thresholds are satisfied, the composite key requirement is considered to be met.

    - #### getLeafKeys

          @NotNull
          public java.util.Set<java.security.PublicKey> getLeafKeys()

      Set of all leaf keys of that `class CompositeKey`.

      See Also:
        `class CompositeKey`

    - #### equals

          public boolean equals(@Nullable
                                java.lang.Object other)

    - #### hashCode

          public int hashCode()

    - #### toString

          @NotNull
          public java.lang.String toString()

    - #### getThreshold

          public int getThreshold()

      specifies the minimum total weight required

      (in the simple case – the minimum number of childsignatures required) to satisfy the sub-tree rooted at this node.